<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVehicleResult_V5 ArrayType
 * @subpackage Arrays
 */
class ArrayOfVehicleResult_V5 extends AbstractStructArrayBase
{
    /**
     * The VehicleResult_V5
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\VehicleResult_V5[]
     */
    public $VehicleResult_V5;
    /**
     * Constructor method for ArrayOfVehicleResult_V5
     * @uses ArrayOfVehicleResult_V5::setVehicleResult_V5()
     * @param \StructType\VehicleResult_V5[] $vehicleResult_V5
     */
    public function __construct(array $vehicleResult_V5 = array())
    {
        $this
            ->setVehicleResult_V5($vehicleResult_V5);
    }
    /**
     * Get VehicleResult_V5 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\VehicleResult_V5[]|null
     */
    public function getVehicleResult_V5()
    {
        return isset($this->VehicleResult_V5) ? $this->VehicleResult_V5 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setVehicleResult_V5 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVehicleResult_V5 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVehicleResult_V5ForArrayConstraintsFromSetVehicleResult_V5(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfVehicleResult_V5VehicleResult_V5Item) {
            // validation for constraint: itemType
            if (!$arrayOfVehicleResult_V5VehicleResult_V5Item instanceof \StructType\VehicleResult_V5) {
                $invalidValues[] = is_object($arrayOfVehicleResult_V5VehicleResult_V5Item) ? get_class($arrayOfVehicleResult_V5VehicleResult_V5Item) : sprintf('%s(%s)', gettype($arrayOfVehicleResult_V5VehicleResult_V5Item), var_export($arrayOfVehicleResult_V5VehicleResult_V5Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The VehicleResult_V5 property can only contain items of type \StructType\VehicleResult_V5, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set VehicleResult_V5 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\VehicleResult_V5[] $vehicleResult_V5
     * @return \ArrayType\ArrayOfVehicleResult_V5
     */
    public function setVehicleResult_V5(array $vehicleResult_V5 = array())
    {
        // validation for constraint: array
        if ('' !== ($vehicleResult_V5ArrayErrorMessage = self::validateVehicleResult_V5ForArrayConstraintsFromSetVehicleResult_V5($vehicleResult_V5))) {
            throw new \InvalidArgumentException($vehicleResult_V5ArrayErrorMessage, __LINE__);
        }
        if (is_null($vehicleResult_V5) || (is_array($vehicleResult_V5) && empty($vehicleResult_V5))) {
            unset($this->VehicleResult_V5);
        } else {
            $this->VehicleResult_V5 = $vehicleResult_V5;
        }
        return $this;
    }
    /**
     * Add item to VehicleResult_V5 value
     * @throws \InvalidArgumentException
     * @param \StructType\VehicleResult_V5 $item
     * @return \ArrayType\ArrayOfVehicleResult_V5
     */
    public function addToVehicleResult_V5(\StructType\VehicleResult_V5 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\VehicleResult_V5) {
            throw new \InvalidArgumentException(sprintf('The VehicleResult_V5 property can only contain items of type \StructType\VehicleResult_V5, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->VehicleResult_V5[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\VehicleResult_V5|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\VehicleResult_V5|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\VehicleResult_V5|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\VehicleResult_V5|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\VehicleResult_V5|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VehicleResult_V5
     */
    public function getAttributeName()
    {
        return 'VehicleResult_V5';
    }
}
